
//+------------------------------------------------------------------+
//|                                                   TrendMagic.mq4 |
//|                              Tidied up by TudorGirl  28 May 2009 |
//|                                              AnneTudor@ymail.com |
//+------------------------------------------------------------------+

#property indicator_chart_window
#property indicator_buffers 1
#property indicator_color1 Black
#property indicator_width1 1

//+------------------------------------------------------------------+

extern int CCI = 50;
extern int ATR = 5;

//+------------------------------------------------------------------+

double buffer[];

//+------------------------------------------------------------------+

int init()
{
   SetIndexStyle(0, DRAW_LINE, STYLE_SOLID, 2);
   SetIndexBuffer(0, buffer);
   return (0);
}

//+------------------------------------------------------------------+

int deinit()
{
   return (0);
}

//+------------------------------------------------------------------+

int start()
{
   double curCCI,lagCCI,atr;
   int lag;


   int counted_bars = IndicatorCounted();
   if (counted_bars < 0) return (-1);
   if (counted_bars > 0) counted_bars--;
   int limit = Bars - counted_bars;

 
  
   for (int shift = limit; shift >= 0; shift--)
   {
      lag = shift + 1;
      
      curCCI = iCCI(NULL, 0, CCI, PRICE_TYPICAL, shift);
      lagCCI = iCCI(NULL, 0, CCI, PRICE_TYPICAL,   lag);
         atr = iATR(NULL, 0, ATR, shift);
    
     if (curCCI >= 0)
      {
         buffer[shift] = Low[shift] - atr;
         if (buffer[shift] < buffer[lag])  buffer[shift] = buffer[lag];
      }
      else
      {
         if (curCCI <= 0)
         {
          buffer[shift] = High[shift] + atr;
          if (buffer[shift] > buffer[lag]) buffer[shift] = buffer[lag];
         }
      }
   }

   return (0);
}

//+------------------------------------------------------------------+
//+------------------------------------------------------------------+

